/// Copyright (c) 2010 Ruben Penalva. All rights reserved.
/// Redistribution and use in source and binary forms, with or without modification, 
/// are permitted provided that the following conditions are met:
///    1. Redistributions of source code must retain the above copyright notice, this 
///    list of conditions and the following disclaimer.
///    2. Redistributions in binary form must reproduce the above copyright notice,
///    this list of conditions and the following disclaimer in the documentation and/or
///    other materials provided with the distribution.
///    3. The name of the author may not be used to endorse or promote products derived
///    from this software without specific prior written permission.
///
/// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
/// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
/// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, 
/// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
/// TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
/// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
/// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#include "Win32Window.h"

#include "Exception.h"

using namespace TestFrameWork;

Win32Window::Win32Window(void)
{
	RECT windowRect;
	memset(&windowRect, 0, sizeof(RECT));
	windowRect.right = 0;
	windowRect.bottom = 0;

	WNDCLASS wc;
	memset(&wc, 0, sizeof(WNDCLASS));
	wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.lpfnWndProc = (WNDPROC) DefWindowProc;
	wc.hInstance = GetModuleHandle(0);
	wc.hIcon = LoadIcon(NULL, IDI_WINLOGO);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.lpszClassName = L"Window32";
	wc.hbrBackground  = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName = 0;

	// Register The Window Class
	if (!RegisterClass(&wc))
	{
		throw Exception();
	}

	DWORD dwExStyle = WS_EX_APPWINDOW;
	DWORD dwStyle = WS_OVERLAPPEDWINDOW;

	// Adjust Window To True Requested Size
	AdjustWindowRectEx(&windowRect, dwStyle, FALSE, dwExStyle);

	// Create The Window
	m_hwnd = CreateWindowEx(dwExStyle, L"Window32", L"Window32", dwStyle, 0, 0, 0, 0, 0, 0, GetModuleHandle(0), 0);
	if (!m_hwnd)
	{
		throw Exception();
	}

	 m_hdc = GetDC(m_hwnd);
}

Win32Window::~Win32Window(void)
{
	DestroyWindow(m_hwnd);
	UnregisterClass(L"Window32", GetModuleHandle(0));
}
